var PrefKeys = PrefKeys || {};

PrefKeys.timeout = "TIMEOUT";
PrefKeys.checkDict = "CHECKDICT";
PrefKeys.languages = "LANGUAGES";
PrefKeys.defaultPrefix = "DEFAULT_";
PrefKeys.userPrefix = "USER_";

/* Load Preferences. If a preference has not been store yet, save initial value as default. If DEFAULTVALUE is set to TRUE, default values are loaded. */
function loadPreferences(defaultvalue) {
  /* User Preferences or default values? */
  var prefix = "";
  if(defaultvalue) {
  	prefix = PrefKeys.defaultPrefix;
  } else {
  	prefix = PrefKeys.userPrefix;
  }

  /* timeout value */
  var timeout = widget.preferenceForKey(prefix+PrefKeys.timeout);
  if(timeout != undefined && timeout != '') {
    $('#inputtimeout').val(timeout);
  } else { /* Loaded the first time. Store current value as default. */
  	widget.setPreferenceForKey($('#inputtimeout').val(),
  							   PrefKeys.defaultPrefix+PrefKeys.timeout);
  }

  /* Dictionary check enabled/disabled. */
  var checkDict = widget.preferenceForKey(prefix+PrefKeys.checkDict);
  if(checkDict != undefined && checkDict != '') {
    if(checkDict == "true") {
      $('#checkdict').attr("checked","checked");
    } else {
      $('#checkdict').removeAttr("checked");
    }
  } else { /* Loaded the first time. Store current value as default. */
  	widget.setPreferenceForKey($('#checkdict').attr("checked"),
  							   PrefKeys.defaultPrefix+PrefKeys.checkDict);
  }

  /* Selected languages. */
  var langs = widget.preferenceForKey(prefix+PrefKeys.languages);
  if(langs != undefined && langs != '') {
    $('select#language option').removeAttr('selected');
    var langs = langs.split("|");
    $.each(langs, function(key,value) {
      $('select#language option[value='+value+']').attr('selected','selected');
    });
  } else { /* Loaded the first time. Store current value as default. */
	var langs = "";
	$.each( $('select#language').val() ,function (key,value) {
	  langs += value + "|";
	});
  	widget.setPreferenceForKey(langs, PrefKeys.defaultPrefix+PrefKeys.languages);
  }
}

function savePreferences() {
  widget.setPreferenceForKey($('#inputtimeout').val(),PrefKeys.userPrefix+PrefKeys.timeout);
  widget.setPreferenceForKey($('#checkdict').attr("checked"),PrefKeys.userPrefix+PrefKeys.checkDict);
  var langs = "";
  $.each( $('select#language').val() ,function (key,value) {
    langs += value + "|";
  });
  widget.setPreferenceForKey(langs,PrefKeys.userPrefix+PrefKeys.languages);
}

function restoreDefaultOptions () {
	loadPreferences(true);
	savePreferences();
}
