var timer = null; // this timer is used to delay complete checks

/* Define relations between tab and menu. */
function assignTabs() {
	$('.menuselect > li a').each(function() {
		$($(this).attr('href')).data('tab', $(this).parents('.menuselect > li'));
	});
}

function addEventHandler() {
	assignTabs();

	// disable default link behaviour
	$("a, input:submit").live("click", function(event){
	  event.preventDefault();
	})
    // use openURL for external links
    .filter('a.external').click(function() {
    	 widget.openURL(this.href);
    });

	$('#password').keyup(function() { checkAndDisplay(false) }); // do a fast check on every key
	$('#checkdict, #language').change(changeDicts); // check after changing setting
	$('#checkdict, #language, #inputtimeout').change(savePreferences);
	$('#saveoptions').click(function() { checkAndDisplay(true) });
	$('#restoredefaultoptions').click(restoreDefaultOptions);

	// do an intensive check after time delay defined by the user
	$('#password').keyup(function() {
			window.clearTimeout(timer);
			timer = window.setTimeout("checkAndDisplay(true)", $('#inputtimeout').val() );
	});

	// Links that are assigned to menus (and vice versa):
	$('ul.menuselect > li a, .menushortcut').click(function(){
			showMenu($($(this).attr('href')));
	});

}

function changeDicts() {
	// to be executed, when user changes languages or enables/disables dict check

	// display lang count and hints
	$('#selectedlangcount').text($('#language').val().length);

	if( ($('#language').val().length > 0) && $('#checkdict').attr('checked') ) {
		$('.dictnoteon').show();
		$('.dictnoteoff').hide();
	} else {
		$('.dictnoteon').hide();
		$('.dictnoteoff').show();
	}

	// recheck
	checkAndDisplay(true);
}

/* switch between submenus */
function showMenu(toShow) {
	$(toShow).siblings(':visible').hide();
	$(toShow).show();
	markCorrespondingTab(toShow);
}

function markCorrespondingTab(field) {
	if(tab = $(field).data('tab')) {
		tab.addClass('selected').siblings().removeClass('selected');
	}
}

// perform a password check. COMPLETE includes dict check and detailed result
function checkAndDisplay(complete) {
	var score = $('#score');
	if($('#password').val() == '') {
		for(var i = 0; i < 5; i++) {
			score.removeClass('strength'+i);
		}
		score.removeClass('temp').removeClass('complete').text('');

		$('#props .prop').removeClass('good').removeClass('bad').addClass('unknown');
	} else {
		var res = checkPW($('#password').val(), $('#checkdict').attr("checked") && complete, $('#language').val());
		switch(res[0]) {
			case 0:
				score.text("useless");
				break;
			case 1:
				score.text("weak");
				break;
			case 2:
				score.text("medium");
				break;
			case 3:
				score.text("strong");
				break;
			case 4:
				score.text("very strong");
				break;
			default:
				score.text("(error)");
				break;

		}
		for(var i = 0; i < 5; i++) {
			if(i != res[0]) {
				score.removeClass('strength'+i);
			}
		}
		score.addClass('strength'+res[0]);
		if(complete) {
			$('#score').addClass('complete').removeClass('temp');
			for(var prop in res[1])  {
				if(res[1][prop]==0) {
					$('#prop'+prop).addClass("bad");
					$('#prop'+prop).removeClass("good");
					$('#prop'+prop).removeClass("unknown");
				} else if (res[1][prop]==1) {
					$('#prop'+prop).removeClass("bad");
					$('#prop'+prop).addClass("good");
					$('#prop'+prop).removeClass("unknown");
				} else {
					$('#prop'+prop).removeClass("bad");
					$('#prop'+prop).removeClass("good");
					$('#prop'+prop).addClass("unknown");
				}
			};
	 	} else {
	 		$('#score').removeClass('complete').addClass('temp');
	 	}
	}
}

$(function() { // on startup:
	addEventHandler();
	getWidgetversion();
	loadPreferences();
	$('#password').focus();
} );
